unit FileU;

(*
//  C-to-Quadcode Compiler
//  ----------------------
//  Practical Work:
//      Compilers Summer Semester 2008
//      (Lecture by Mr. Schwinn)
//
//  Course:
//      TAI-06-ABC
//
//  Developers:
//     Kevin Niehage   (Matrikelnummer: 280888)
//     Michaela Hansel (Matrikelnummer: 221664)
*)

// IMPLEMENTATION STATUS: DONE

interface

uses
  ConstsU,
  ErrorsU,
  TypesU;

function ParseFileParts(const AFileParts : String) : TFileInfoArray;

implementation

function ParseFileParts(const AFileParts : String) : TFileInfoArray;
var
  LBracketCount : LongInt;
  LBuffer       : String;
  LCount        : LongInt;
  LIndex        : LongInt;
  LNext         : Char;
  LStatus       : TFileStatus;
  LType         : TFileInfoType;
begin
  SetLength(Result, 0);

  SetLength(LBuffer, Length(AFileParts));
  LCount  := 0;

  LBracketCount := 0;
  LNext         := #0;
  LStatus       := fsWaitForNext;
  LType         := fitVariable;

  LIndex := 1;
  while (LIndex <= Length(AFileParts)) do
  begin
    LNext := AFileParts[LIndex];

    case LStatus of
      fsWaitForNext :
      begin
        case LNext of
          #9, #10, #13, #32, #59 :
          begin
            // do nothing
          end;

          'A'..'Z', 'a'..'z' : // type
          begin
            Inc(LCount);
            LBuffer[LCount] := LNext;

            LStatus := fsWaitForEnd;
          end;
        else
          raise TFileInfoException.Create(BuildParseError(AFileParts, LNext, LBuffer, LCount, CErrorUnknownTypeCharacter));
        end;
      end;

      fsWaitForEnd :
      begin
        Inc(LCount);
        LBuffer[LCount] := LNext;

        case LNext of
          '(' : // forward
          begin
            LType := fitForward;

            LStatus := fsWaitForForwardEnd;
          end;

          '=' : // variable
          begin
            LType := fitVariable;

            LStatus := fsWaitForVariableEnd;
          end;

          ';' : // end
          begin
            LStatus := fsWriteEntry;
            Dec(LIndex); // reset lookahead
          end;
        end;
      end;

      fsWaitForVariableEnd :
      begin
        Inc(LCount);
        LBuffer[LCount] := LNext;

        case LNext of
          ';' :
          begin
            LStatus := fsWriteEntry;
            Dec(LIndex); // reset lookahead
          end;
        end;
      end;

      fsWaitForForwardEnd :
      begin
        Inc(LCount);
        LBuffer[LCount] := LNext;

        case LNext of
          ';' :
          begin
            LStatus := fsWriteEntry;
            Dec(LIndex); // reset lookahead
          end;

          '{' :
          begin
            LBracketCount := 1;
            LType         := fitFunction;

            LStatus := fsWaitForFunctionEnd;
          end;
        end;
      end;

      fsWaitForFunctionEnd :
      begin
        Inc(LCount);
        LBuffer[LCount] := LNext;

        case LNext of
          '{' :
          begin
            Inc(LBracketCount);
          end;

          '}' :
          begin
            Dec(LBracketCount);

            if (LBracketCount = 0) then
            begin
              LStatus := fsWriteEntry;
              Dec(LIndex); // reset lookahead
            end;
          end;
        end;
      end;

      fsWriteEntry :
      begin
        SetLength(LBuffer, LCount);

        SetLength(Result, Succ(Length(Result)));
        Result[High(Result)].fSource := LBuffer;
        Result[High(Result)].fType   := LType;

        SetLength(LBuffer, Length(AFileParts) - LCount);
        LCount := 0;
        LType  := fitVariable;

        LStatus := fsWaitForNext;
//        Dec(LIndex); // reset lookahead
      end;
    end;

    Inc(LIndex);
  end;

  if (LStatus <> fsWaitForNext) then
    raise TFileInfoException.Create(BuildParseError(AFileParts, LNext, LBuffer, LCount, CErrorNoEnding));
end;

end.
