unit QuotesU;

(*
//  C-to-Quadcode Compiler
//  ----------------------
//  Practical Work:
//      Compilers Summer Semester 2008
//      (Lecture by Mr. Schwinn)
//
//  Course:
//      TAI-06-ABC
//
//  Developers:
//     Kevin Niehage   (Matrikelnummer: 280888)
//     Michaela Hansel (Matrikelnummer: 221664)
*)

// IMPLEMENTATION STATUS: DONE

interface

uses
  ConstsU,
  ErrorsU,
  TypesU;

function KillQuotes(const ASource : String) : String;

implementation

function KillQuotes(const ASource : String) : String;
var
  LBuffer : Char;
  LCount  : LongInt;
  LIndex  : LongInt;
  LNext   : Char;
  LStatus : TQuoteStatus;
begin
  SetLength(Result, Length(ASource));
  LCount  := 0;

  LBuffer := #0;
  LNext   := #0;
  LStatus := qsWaitForNext;
  
  for LIndex := 1 to Length(ASource) do
  begin
    LNext := ASource[LIndex];

    case LStatus of
      qsWaitForNext :
      begin
        case LNext of
          '/' :
          begin
            LBuffer := LNext;

            LStatus := qsQuoteFirst;
          end;
        else
          Inc(LCount);
          Result[LCount] := LNext;
        end;
      end;

      qsQuoteFirst :
      begin
        case LNext of
          '/' :
          begin
            LStatus := qsLineQuote;
          end;

          '*' :
          begin
            LStatus := qsBlockQuote;
          end;
        else
          Inc(LCount);
          Result[LCount] := LBuffer;
          Inc(LCount);
          Result[LCount] := LNext;

          LStatus := qsWaitForNext;
        end;

        LBuffer := #0;
      end;

      qsLineQuote :
      begin
        case LNext of
          #10, #13 :
          begin
            Inc(LCount);
            Result[LCount] := LNext;

            LStatus := qsWaitForNext;
          end;
        end;
      end;

      qsBlockQuote :
      begin
        case LNext of
          '*' :
          begin
            LStatus := qsBlockQuoteAfterFirst;
          end;
        end;
      end;

      qsBlockQuoteAfterFirst :
      begin
        case LNext of
          '/' :
          begin
            LStatus := qsWaitForNext;
          end;
        else
          LStatus := qsBlockQuote;
        end;
      end;
    end;
  end;

  if (LStatus = qsLineQuote) then
    LStatus := qsWaitForNext;
  if (LStatus <> qsWaitForNext) then
    raise TQuoteException.Create(BuildParseError(ASource, LNext, Result, LCount, CErrorNoQuoteEnding));

  SetLength(Result, LCount);
end;

end.
